//
//  Biblioteca.h
//  PowerComicReader
//
//  Created by Sebastian Suelves Selles on 29/03/13.
//  Copyright (c) 2013 Sebastian Suelves Selles. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "Comic.h"
#import "CDataColeccion.h"
#import "CDataComic.h"

@interface Biblioteca : NSObject
@property (nonatomic, strong) NSManagedObjectContext *managedObjectContext;
@property (nonatomic, strong) NSString *coleccionActiva;


-(NSMutableArray *) getComicsColleccion:(NSString*) coleccion;
-(NSMutableArray *) getAllComics;
-(NSMutableArray *) getColecciones;
-(void) importaComics;
-(void) removeComicsAtIndex:(NSUInteger) indice;
-(void) removeComicsObject:(Comic *)object;
-(void) insertComicsObject:(Comic *)object inComicsAtIndex:(NSUInteger)index AndInsertInCoreData:(BOOL) insertarCoreData;
-(void) moveComicFromIndex:(NSUInteger) desde toIndex:(NSUInteger) hasta;
-(Comic *) getComicAtIndex:(NSUInteger) indice;
-(NSUInteger) getComicsCount;
- (id)initWithColeccion:(NSFetchedResultsController *)comicsColeccion ofColeccion:(CDataColeccion *)coleccion;
-(void) trasladaComic:(Comic *)comic toColeccion:(NSString *)coleccionDestino;
-(void) refrescaBiblioteca;

@end
