//
//  ColeccionViewController.h
//  PowerComicReader
//
//  Created by Sebastian Suelves Selles on 21/04/13.
//  Copyright (c) 2013 Sebastian Suelves Selles. All rights reserved.
//

#import <UIKit/UIKit.h>

//definicion del protocolo de comunicacion de la coleccion seleccionada a implementar en el delegado
@protocol ColeccionViewDelegate <NSObject>

@required
-(void)coleccionSeleccionada:(NSString *)nuevaColeccion;
@end

//definicion de interfaz
@interface ColeccionViewController : UIViewController <UITableViewDataSource, UITableViewDelegate, UITextFieldDelegate>
@property (nonatomic, weak) id<ColeccionViewDelegate> delegate;
//array para almacenar el modelo de datos
@property (nonatomic, strong) NSMutableArray *listaColecciones;

@property (nonatomic, strong) NSString *coleccionActual;

//Core DATA
@property (nonatomic, strong) NSManagedObjectContext *managedObjectContext;
@end
