//
//  EstanteriaViewController.m
//  PowerComicReader
//
//  Created by Sebastian Suelves Selles on 17/03/13.
//  Copyright (c) 2013 Sebastian Suelves Selles. All rights reserved.
//

#import "EstanteriaViewController.h"
#import "Comic.h"
#import "CelulaComic.h"
#import "Biblioteca.h"
#import "VisualizadorComicViewController.h"
#import "LXReorderableCollectionViewFlowLayout.h"


//@interface EstanteriaViewController () <UICollectionViewDataSource, UICollectionViewDelegateFlowLayout>
@interface EstanteriaViewController () <LXReorderableCollectionViewDataSource, LXReorderableCollectionViewDelegateFlowLayout>
@property (weak, nonatomic) IBOutlet UIToolbar *toolbar;
@property (weak, nonatomic) IBOutlet UIBarButtonItem *botonColecciones;
@property (weak, nonatomic) IBOutlet UIBarButtonItem *botonEditar;
@property (weak, nonatomic) IBOutlet UIBarButtonItem *botonTrasladar;
@property (weak, nonatomic) IBOutlet UIBarButtonItem *botonEliminar;
@property (weak, nonatomic) IBOutlet UIBarButtonItem *botonSeleccionarTodo;
@property (weak, nonatomic) IBOutlet UICollectionView *collectionView;
@property (strong, nonatomic) NSMutableArray *comicsSeleccionados;

@property (strong, nonatomic) NSMutableArray     *todosElementosToolbar;
//@property (strong, nonatomic) NSMutableArray *comicsColeccion;

@property (nonatomic) BOOL modoEdicion;

@property (weak, nonatomic) IBOutlet UILabel *labelColeccion;

@property (strong, nonatomic) Biblioteca *biblioteca;
@end

@implementation EstanteriaViewController

-(Biblioteca *)biblioteca
{
    if (!_biblioteca)
    {
        _biblioteca = [[Biblioteca alloc]init];
    }
    return _biblioteca;
}

-(NSMutableArray *)comicsSeleccionados
{
    if (!_comicsSeleccionados)
    {
        _comicsSeleccionados = [[NSMutableArray alloc] init];
    }
    return _comicsSeleccionados;
}

- (IBAction)botonColeccionesPulsado:(UIBarButtonItem *)sender {
    //TODO
    [self.collectionView reloadData];
    NSLog(@"Pulsado Colecciones");
}

- (IBAction)botonTrasladarPulsado:(UIBarButtonItem *)sender {
    NSLog(@"Pulsado Trasladar");
}

- (IBAction)botonEliminarPulsado:(UIBarButtonItem *)sender {
    NSLog(@"Pulsado Eliminar");
    
    for (Comic *comic in [self.comicsSeleccionados copy]) {
        [self.biblioteca removeComicsObject:comic];
        [self.comicsSeleccionados removeObject:comic];
    }
    dispatch_async(dispatch_get_main_queue(), ^{
        //recargar datos collectionview
        [self.collectionView reloadData];
    });
}

- (IBAction)botonSeleccionarTodoPulsado:(UIBarButtonItem *)sender {
    NSLog(@"Pulsado Seleccionar Todo");
    [self.comicsSeleccionados removeAllObjects];
    for (NSIndexPath *index in [self.collectionView indexPathsForVisibleItems]) {
        [self.collectionView selectItemAtIndexPath:index animated:YES scrollPosition:UICollectionUpdateActionNone];
        self.comicsSeleccionados = [self.biblioteca getAllComics];
        self.botonEliminar.enabled = YES;
        self.botonTrasladar.enabled = YES;
    }
}


- (IBAction)botonEditarPulsado:(UIBarButtonItem *)sender {
    //TODO
     NSLog(@"Pulsado Editar");
    
    self.modoEdicion = !self.modoEdicion;
    
    if (self.modoEdicion)
    {
        NSMutableArray *items = [self.todosElementosToolbar mutableCopy];
        
        [items removeObject:self.botonColecciones];
        self.toolbar.items = items;
        
        self.botonEditar.style = UIBarButtonItemStyleDone;
        self.botonEditar.title = @"Ok";
        
        [self.collectionView setAllowsMultipleSelection:YES];
    }
    else
    {
        NSMutableArray *items = [self.todosElementosToolbar mutableCopy];
        
        [items removeObject:self.botonTrasladar];
        [items removeObject:self.botonEliminar];
        [items removeObject:self.botonSeleccionarTodo];
        self.toolbar.items = items;
        
        self.botonEditar.style = UIBarButtonItemStyleBordered;
        self.botonEditar.title = @"Editar";
        
        [self.collectionView setAllowsMultipleSelection:NO];
        

        for (NSIndexPath *indice in self.collectionView.indexPathsForSelectedItems) {
            NSLog(@"objeto seleccionado");
            
            [self.collectionView deselectItemAtIndexPath:indice animated:NO];
        }
        NSLog(@"objetos seleccionados: %lu", (unsigned long)[self.comicsSeleccionados count]);
        [self.comicsSeleccionados removeAllObjects];
        
    }
}

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view.
    self.view.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"bg_cork.png"]];
    
    self.modoEdicion = NO;
    
    self.botonEliminar.enabled = NO;
    self.botonTrasladar.enabled = NO;
//    self.botonSeleccionarTodo.enabled = NO;
    
    // Hacemos copia seguridad toolbar para poder eliminar botones ocultos
    self.todosElementosToolbar = [self.toolbar.items mutableCopy];
    
    // Eliminamos en una copia temporal los botones a ocultar y se los asignamos al toolbar
    NSMutableArray *items = [self.todosElementosToolbar mutableCopy];
    [items removeObject: self.botonEliminar];
    [items removeObject:self.botonSeleccionarTodo];
    [items removeObject:self.botonTrasladar];
    self.toolbar.items = items;

//    // Restauramos toolbar y Activamos todo
//    self.toolbar.items = self.todosElementosToolbar;
//    self.botonEliminar.enabled = YES;
//    self.botonTrasladar.enabled = YES;
//    self.botonSeleccionarTodo.enabled = YES;
    

//    [self.collectionView registerClass:[UICollectionViewCell class] forCellWithReuseIdentifier:@"CelulaComic"];

}



- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - UICollectionView Datasource
- (NSInteger)collectionView:(UICollectionView *)view numberOfItemsInSection:(NSInteger)section;
{
    return [self.biblioteca getComicsCount];
}

- (NSInteger)numberOfSectionsInCollectionView:(UICollectionView *)collectionView
{
    return 1;
}

- (UICollectionViewCell *)collectionView:(UICollectionView *)cv cellForItemAtIndexPath:(NSIndexPath *)indexPath
{
    CelulaComic *cell = [cv dequeueReusableCellWithReuseIdentifier:@"CelulaComic" forIndexPath:indexPath];
    cell.backgroundColor = [UIColor whiteColor];
    //Comic *comic = self.comicsColeccion[indexPath.row];
    Comic *comic = [self.biblioteca getComicAtIndex:indexPath.row];
    cell.thumnail = [comic imagenMiniatura];
    
    return cell;
}


#pragma mark - UICollectionViewDelegate

- (void)collectionView:(UICollectionView *)collectionView didSelectItemAtIndexPath:(NSIndexPath *)indexPath
{
    if (!self.modoEdicion) {
        Comic *comic = [self.biblioteca getComicAtIndex:indexPath.row];
        [self performSegueWithIdentifier:@"VisualizadorComic" sender:comic];
        [self.collectionView deselectItemAtIndexPath:indexPath animated:YES];
    }
    else
    {
        Comic *comic = [self.biblioteca getComicAtIndex:indexPath.row];
        [self.comicsSeleccionados addObject:comic];
        self.botonEliminar.enabled = YES;
        self.botonTrasladar.enabled = YES;
    }
}

- (void)collectionView:(UICollectionView *)collectionView didDeselectItemAtIndexPath:(NSIndexPath *)indexPath
{
    if (self.modoEdicion) {
        Comic *comic = [self.biblioteca getComicAtIndex:indexPath.row];
        [self.comicsSeleccionados removeObject:comic];
        if ([self.comicsSeleccionados count]>0)
        {
            self.botonTrasladar.enabled = NO;
            self.botonEliminar.enabled = NO;
        }
    }
}

- (CGSize)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout sizeForItemAtIndexPath:(NSIndexPath *)indexPath
{
    CGSize retval = CGSizeMake(150, 200);
    
    retval.height += 20;
    retval.width += 20;
    return retval;
}

- (UIEdgeInsets)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout insetForSectionAtIndex:(NSInteger)section
{
    return UIEdgeInsetsMake(20, 20, 20, 20);
}

#pragma mark - segue
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
{
    if ([segue.identifier isEqualToString:@"VisualizadorComic"])
    {
        VisualizadorComicViewController *vc = segue.destinationViewController;
        vc.comic = sender;
    }
}

#pragma mark - LXReorderableCollectionViewDataSource methods

- (void)collectionView:(UICollectionView *)collectionView itemAtIndexPath:(NSIndexPath *)fromIndexPath willMoveToIndexPath:(NSIndexPath *)toIndexPath
{
    Comic *comic = [self.biblioteca getComicAtIndex:fromIndexPath.item];
    
    [self.biblioteca removeComicsAtIndex:fromIndexPath.item];
    [self.biblioteca insertComicsObject:comic inComicsAtIndex:toIndexPath.item];
}

- (BOOL)collectionView:(UICollectionView *)collectionView canMoveItemAtIndexPath:(NSIndexPath *)indexPath
{
    return YES;
}

- (BOOL)collectionView:(UICollectionView *)collectionView itemAtIndexPath:(NSIndexPath *)fromIndexPath canMoveToIndexPath:(NSIndexPath *)toIndexPath {
    return YES;
}

#pragma mark - LXReorderableCollectionViewDelegateFlowLayout methods

- (void)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout *)collectionViewLayout willBeginDraggingItemAtIndexPath:(NSIndexPath *)indexPath {
    NSLog(@"will begin drag");
}

- (void)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout *)collectionViewLayout didBeginDraggingItemAtIndexPath:(NSIndexPath *)indexPath {
    NSLog(@"did begin drag");
}

- (void)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout *)collectionViewLayout willEndDraggingItemAtIndexPath:(NSIndexPath *)indexPath {
    NSLog(@"will end drag");
}

- (void)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout *)collectionViewLayout didEndDraggingItemAtIndexPath:(NSIndexPath *)indexPath {
    NSLog(@"did end drag");
}

@end
