//
//  PreferenciasUsuario.m
//  PowerComicReader
//
//  Created by Sebastian Suelves Selles on 22/04/13.
//  Copyright (c) 2013 Sebastian Suelves Selles. All rights reserved.
//

#import "PreferenciasUsuario.h"

@implementation PreferenciasUsuario

- (id) init
{
    self = [super init];
    
    if (self) {
        //al inicializar el objeto cargamos las preferencias del usuario
        [self cargaPreferencias];
    }
    return self;
}

- (void)cargaPreferencias
{
    //Cargamos preferencias del usuario
    NSUserDefaults *userDefaults = [NSUserDefaults standardUserDefaults];
    
    NSMutableDictionary *defaultDict = [[NSMutableDictionary alloc] initWithCapacity:3];
    [defaultDict setObject:@"Madera" forKey:@"estiloInterfaz"];
    [defaultDict setObject:@"YES" forKey:@"usarDobleTapParaZoomInOut"];
    [defaultDict setObject:@"1.50" forKey:@"nivelZoomDobleTap"];
    [userDefaults registerDefaults:defaultDict];
    [userDefaults synchronize];
    
    self.estilo = [userDefaults stringForKey:@"estiloInterfaz"];
    self.usarZoomDobleTap = [userDefaults boolForKey:@"usarDobleTapParaZoomInOut"];
    self.nivelZoomDobleTap = [userDefaults stringForKey:@"nivelZoomDobleTap"];
    
    if ([self.estilo isEqualToString:@"Blanco"]) {
        self.backgroundColor = [UIColor whiteColor];
     }
    
    if ([self.estilo isEqualToString:@"Negro"]) {
        self.backgroundColor = [UIColor blackColor];
    }
    
    if ([self.estilo isEqualToString:@"Papel"]) {
        self.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"bg_cork.png"]];
    }
    if ([self.estilo isEqualToString:@"Madera"]) {
        self.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"bg_madera.png"]];
    }
    
}

@end
